
#include "objects.h"
#include "unix.h"
#include "x.h"
#include "xt.h"
#include "externs.h"
#include <sys/time.h>

void readBoxValues();
int checkBoxValues();
extern ObjectStruct ObjectValues;

#define ASCIITEXTATTRIBUTES \
    XtNeditType, XawtextEdit, \
    XtNtype, XawAsciiString, \
    XtNuseStringInPlace, True, \
    XtNresizable, True, \
    XtNresize, XawtextResizeWidth, \
    XtNright, XtChainRight,


typedef struct _Text {
    char *filetext;
    char *textC;
    char *text4, *text5, *text6,
    *textLL, *textUR,
    *n1, *n2;
} 
Text, *TextPtr;


typedef struct _Widg {
    Widget cl, tp, bt;
} 
Widg, *WidgPtr;


typedef struct _Togg {
    Widget ei, or;
} 
Togg, *ToggPtr;


typedef struct _Pass {
    TextPtr text;
    WidgPtr widg;
    ToggPtr togg;
} 
Pass, *PassPtr;


/*
 *   Function Name: getOFFValues
 *   Description: Creates and pops up the Dialog widget to ask for a new
 *                input values
 *   Arguments: w - the command button that activated this function.
 *   Returns: none.
 */

void
generateBox( toplevel )
Widget toplevel;
{
    TextPtr text = (TextPtr) malloc( sizeof (Text) );
    WidgPtr widg = (WidgPtr) malloc( sizeof (Widg) );
    PassPtr pass = (PassPtr) malloc( sizeof (Pass) );
    ToggPtr togg = (ToggPtr) malloc( sizeof (Togg) );

    Widget g_popup, g_form;
    Widget g_label0, g_filelabel, g_filetext;
    Widget g_label4, g_label5, g_label6, g_label7;
    Widget g_text4, g_text5, g_text6;
    Widget g_toggleE, g_toggleO, g_toggle7;
    Widget g_labelC, g_textC;
    Widget g_label000, g_label001, g_label002;
    Widget g_ok, g_cancel;
    Widget g_title1, g_title2;
    Widget g_either, g_or;
    Widget g_labelLL, g_labelUR, g_textLL, g_textUR;

    Position x, y;

    char   string[20];
    String buffer;

    struct timeval tp;
    struct timezone tzp;

    static XtCallbackRec callbacks[] =
    {
        {(XtCallbackProc) NULL, (XtPointer) NULL},
        {(XtCallbackProc) NULL, (XtPointer) NULL},
    };

    ObjectValues.Obj.Box.xaxis = 0.5;
    ObjectValues.Obj.Box.yaxis = 0.5;
    ObjectValues.Obj.Box.zaxis = 0.5;
    ObjectValues.Obj.Box.center.x = 0.0;
    ObjectValues.Obj.Box.center.y = 0.0;
    ObjectValues.Obj.Box.center.z = 0.0;
    ObjectValues.Obj.Box.lowerLeft.x = -0.5;
    ObjectValues.Obj.Box.lowerLeft.y = -0.5;
    ObjectValues.Obj.Box.lowerLeft.z = -0.5;
    ObjectValues.Obj.Box.upperRight.x = 0.5;
    ObjectValues.Obj.Box.upperRight.y = 0.5;
    ObjectValues.Obj.Box.upperRight.z = 0.5;
    ObjectValues.Obj.Box.clockwise = False;

    map_dialog(toplevel, &x, &y);
    g_popup = XtVaCreatePopupShell( "Get Values",
        transientShellWidgetClass, toplevel,
        XtNx, x, XtNy, y,
        NULL );

    g_form = XtVaCreateManagedWidget( "g_form", formWidgetClass, g_popup,
        NULL );

    sprintf( string, "Object : Box" );
    g_label0 = XtVaCreateManagedWidget( "g_label0", labelWidgetClass, g_form,
        XtNlabel, string,
        NULL );

    gettimeofday( &tp, &tzp );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "box_%d.geom", (tp.tv_sec)%1000 );
    text->filetext = XtNewString( buffer );
    g_filelabel = XtVaCreateManagedWidget( "g_filelabel", labelWidgetClass,
        g_form,
        XtNfromVert, g_label0,
        NULL );
    g_filetext = XtVaCreateManagedWidget( "g_filetext", asciiTextWidgetClass,
        g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->filetext,
        XtNlength, 30,
        XtNwidth, 11*strlen(buffer),
        XtNinsertPosition, strlen(buffer),
        XtNfromVert, g_label0,
        XtNfromHoriz, g_filelabel,
        NULL );

    g_label000 = XtVaCreateManagedWidget( "g_label000", labelWidgetClass,g_form,
        XtNfromVert, g_filelabel,
        NULL );
    g_title1 = XtVaCreateManagedWidget( "g_title1", labelWidgetClass, g_form,
        XtNfromVert, g_label000,
        NULL );

    g_either = XtVaCreateManagedWidget( "g_either", labelWidgetClass, g_form,
        XtNfromVert, g_title1,
        XtNborderWidth, 0,
        NULL );

    g_toggleE  = XtVaCreateManagedWidget( "g_toggleE", toggleWidgetClass,g_form,
        XtNfromVert, g_title1,
        XtNfromHoriz, g_either,
        XtNlabel, "+",
        XtNstate, False,
        NULL );

    g_labelC  = XtVaCreateManagedWidget( "g_labelC", labelWidgetClass, g_form,
        XtNwidth, 10*7,
        XtNfromVert, g_either,
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f %.2f %.2f", ObjectValues.Obj.Box.center.x,
        ObjectValues.Obj.Box.center.y, ObjectValues.Obj.Box.center.z );
    text->textC = XtNewString( buffer );
    g_textC = XtVaCreateManagedWidget( "g_textC", asciiTextWidgetClass,
        g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->textC,
        XtNlength, 25,
        XtNwidth, 11*strlen(text->textC),
        XtNinsertPosition, strlen(text->textC),
        XtNfromVert, g_either,
        XtNfromHoriz, g_labelC,
        NULL );

    g_label4 = XtVaCreateManagedWidget( "g_label4", labelWidgetClass, g_form,
        XtNwidth, 10*7,
        XtNfromVert, g_labelC,
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f", ObjectValues.Obj.Box.xaxis );
    text->text4 = XtNewString( buffer );
    g_text4  = XtVaCreateManagedWidget( "g_text4", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text4,
        XtNlength, 5,
        XtNinsertPosition, strlen(text->text4),
        XtNfromVert, g_labelC,
        XtNfromHoriz, g_label4,
        NULL );

    g_label5 = XtVaCreateManagedWidget( "g_label5", labelWidgetClass, g_form,
        XtNwidth, 10*7,
        XtNfromVert, g_label4,
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f", ObjectValues.Obj.Box.yaxis );
    text->text5 = XtNewString( buffer );
    g_text5  = XtVaCreateManagedWidget( "g_text5", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text5,
        XtNlength, 5,
        XtNinsertPosition, strlen(text->text5),
        XtNfromVert, g_label4,
        XtNfromHoriz, g_label5,
        NULL );

    g_label6 = XtVaCreateManagedWidget( "g_label6", labelWidgetClass, g_form,
        XtNwidth, 10*7,
        XtNfromVert, g_label5,
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f", ObjectValues.Obj.Box.zaxis );
    text->text6 = XtNewString( buffer );
    g_text6  = XtVaCreateManagedWidget( "g_text6", asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->text6,
        XtNlength, 5,
        XtNinsertPosition, strlen(text->text6),
        XtNfromVert, g_label5,
        XtNfromHoriz, g_label6,
        NULL );

    g_or = XtVaCreateManagedWidget( "g_or", labelWidgetClass, g_form,
        XtNfromVert, g_label6,
        XtNborderWidth, 0,
        NULL );

    g_toggleO  = XtVaCreateManagedWidget( "g_toggleO", toggleWidgetClass,g_form,
        XtNfromVert, g_label6,
        XtNfromHoriz, g_or,
        XtNlabel, "-",
        XtNstate, True,
        NULL );

    g_labelLL = XtVaCreateManagedWidget( "g_labelLL", labelWidgetClass,
        g_form,
        XtNwidth, 10*9,
        XtNfromVert, g_or,
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f %.2f %.2f", ObjectValues.Obj.Box.lowerLeft.x,
        ObjectValues.Obj.Box.lowerLeft.y, ObjectValues.Obj.Box.lowerLeft.z );
    text->textLL = XtNewString( buffer );
    g_textLL = XtVaCreateManagedWidget( "g_textLL",
        asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->textLL,
        XtNlength, 25,
        XtNwidth, 11*strlen(text->textC),
        XtNinsertPosition, strlen(text->textLL),
        XtNfromVert, g_or,
        XtNfromHoriz, g_labelLL,
        NULL );

    g_labelUR = XtVaCreateManagedWidget( "g_labelUR", labelWidgetClass,
        g_form,
        XtNwidth, 10*9,
        XtNfromVert, g_labelLL,
        NULL );
    buffer = (String) malloc( 30 );
    sprintf( buffer, "%.2f %.2f %.2f", ObjectValues.Obj.Box.upperRight.x,
        ObjectValues.Obj.Box.upperRight.y, ObjectValues.Obj.Box.upperRight.z );
    text->textUR = XtNewString( buffer );
    g_textUR = XtVaCreateManagedWidget( "g_textUR",
        asciiTextWidgetClass, g_form,
        ASCIITEXTATTRIBUTES
        XtNstring, text->textUR,
        XtNlength, 25,
        XtNwidth, 11*strlen(text->textC),
        XtNinsertPosition, strlen(text->textUR),
        XtNfromVert, g_labelLL,
        XtNfromHoriz, g_labelUR,
        NULL );

    g_label001 = XtVaCreateManagedWidget( "g_label001", labelWidgetClass,g_form,
        XtNfromVert, g_labelUR,
        NULL );

    g_title2 = XtVaCreateManagedWidget( "g_title2", labelWidgetClass, g_form,
        XtNfromVert, g_label001,
        NULL );

    g_label7 = XtVaCreateManagedWidget( "g_label7", labelWidgetClass, g_form,
        XtNfromVert, g_title2,
        NULL );
    callbacks[0].callback = (XtCallbackProc) changeSign;
    callbacks[0].closure  = (XtPointer) NULL;
    g_toggle7  = XtVaCreateManagedWidget( "g_toggle7", toggleWidgetClass,g_form,
        XtNcallback, callbacks,
        XtNfromVert, g_title2,
        XtNfromHoriz, g_label7,
        NULL );
    if( ObjectValues.Obj.Box.clockwise )
        XtVaSetValues( g_toggle7, XtNlabel, "+", NULL );
    else
        XtVaSetValues( g_toggle7, XtNlabel, "-", NULL );

    g_label002 = XtVaCreateManagedWidget( "g_label002", labelWidgetClass,g_form,
        XtNfromVert, g_label7,
        NULL );

    togg->ei = g_toggleE;
    togg->or = g_toggleO;
    XtAddCallback( g_toggleE, XtNcallback, changeDoubleSign, togg );
    XtAddCallback( g_toggleO, XtNcallback, changeDoubleSign, togg );

    widg->cl = g_toggle7;
    pass->text = text;
    pass->widg = widg;
    pass->togg = togg;

    callbacks[0].callback = (XtCallbackProc) readBoxValues;
    callbacks[0].closure  = (XtPointer) pass;
    g_ok = XtVaCreateManagedWidget( "g_ok", commandWidgetClass, g_form,
        XtNcallback, callbacks,
        XtNfromVert, g_label002,
        NULL );

    callbacks[0].callback = (XtCallbackProc) DestroyPopupPrompt;
    callbacks[0].closure  = (XtPointer) g_popup;
    g_cancel = XtVaCreateManagedWidget( "g_cancel", commandWidgetClass, g_form,
        XtNcallback, callbacks,
        XtNfromVert, g_label002,
        XtNfromHoriz, g_ok,
        NULL );

/*
    XtRealizeWidget( g_popup );
*/
    XtPopup( g_popup, XtGrabNone );
    XMapRaised( XtDisplay( g_popup ), XtWindow( XtParent( g_popup ) ) );
}


static void
changeSign( widget, client_data, call_data )
Widget widget;
XtPointer call_data, client_data;
{
    Boolean state;

    XtVaGetValues( widget, XtNstate, &state, NULL );
    if( state ) XtVaSetValues( widget, XtNlabel, "+", NULL );
    if( !state ) XtVaSetValues( widget, XtNlabel, "-", NULL );
}


static void
changeDoubleSign( widget, client_data, call_data )
Widget widget;
XtPointer call_data, client_data;
{
    Boolean state;
    ToggPtr toggle = (ToggPtr)client_data;
    Widget togE = toggle->ei;
    Widget togO = toggle->or;

    if( widget == togE ) {
        XtVaGetValues( widget, XtNstate, &state, NULL );
        if( state ) {
            XtVaSetValues( togE, XtNlabel, "-", NULL );
            XtVaSetValues( togO, XtNlabel, "+", NULL );
            XtVaSetValues( togO, XtNstate, False, NULL );
        }
        if( !state ) {
            XtVaSetValues( togE, XtNlabel, "+", NULL );
            XtVaSetValues( togO, XtNlabel, "-", NULL );
            XtVaSetValues( togO, XtNstate, True, NULL );
        }
    }
    if( widget == togO ) {
        XtVaGetValues( widget, XtNstate, &state, NULL );
        if( state ) {
            XtVaSetValues( togO, XtNlabel, "-", NULL );
            XtVaSetValues( togE, XtNlabel, "+", NULL );
            XtVaSetValues( togE, XtNstate, False, NULL );
        }
        if( !state ) {
            XtVaSetValues( togO, XtNlabel, "+", NULL );
            XtVaSetValues( togE, XtNlabel, "-", NULL );
            XtVaSetValues( togE, XtNstate, True, NULL );
        }
    }
}


static void
DestroyPopupPrompt( widget, client_data, call_data )
Widget widget;
XtPointer call_data, client_data;
{
    Widget popup = (Widget)client_data;
    extern char creatingObject;
    creatingObject = False;
    XtPopdown( popup );
    XtDestroyWidget( popup );
}


void
readBoxValues( widget, client_data, call_data )
Widget widget;
XtPointer client_data, call_data;
{
    Widget popup = XtParent( XtParent( widget ) );
    PassPtr pass = (PassPtr) client_data;
    WidgPtr pwidg = (WidgPtr) pass->widg;
    TextPtr ptext = (TextPtr) pass->text;
    ToggPtr ptogg = (ToggPtr) pass->togg;
    extern char creatingObject;

    float xaxis, yaxis, zaxis;
    Point center, lowerLeft, upperRight;
    Boolean clockwise, either, or;
    Status status;
    int primitive=0;

    extern String filename;

    filename = (String) malloc( strlen((const char *)getenv("OBJ_PATH")) + 80 );

    XtVaGetValues( ptogg->ei, XtNstate, &either, NULL );
    or = either ? 0 : 1;

    strcat( strcat( strcpy( filename, (const char *)getenv("OBJ_PATH") ), "/" ), ptext->filetext );
    if( !either ) {
        sscanf( ptext->textC, "%f %f %f", &(center.x),&(center.y),&(center.z) );
        XtFree( ptext->textC );
        sscanf( ptext->text4, "%f", &xaxis );
        XtFree( ptext->text4 );
        sscanf( ptext->text5, "%f", &yaxis );
        XtFree( ptext->text5 );
        sscanf( ptext->text6, "%f", &zaxis );
        XtFree( ptext->text6 );
    }
    else if ( !or ) {
        sscanf( ptext->textLL, "%f %f %f", &(lowerLeft.x), &(lowerLeft.y),
            &(lowerLeft.z) );
        XtFree( ptext->textLL );
        sscanf( ptext->textUR, "%f %f %f", &(upperRight.x), &(upperRight.y),
            &(upperRight.z) );
        XtFree( ptext->textUR );
    }
    XtVaGetValues( pwidg->cl, XtNstate, &clockwise, NULL );

    ObjectValues.Obj.Box.xaxis = xaxis;
    ObjectValues.Obj.Box.yaxis = yaxis;
    ObjectValues.Obj.Box.zaxis = zaxis;
    ObjectValues.Obj.Box.center.x = center.x;
    ObjectValues.Obj.Box.center.y = center.y;
    ObjectValues.Obj.Box.center.z = center.z;
    ObjectValues.Obj.Box.lowerLeft.x = lowerLeft.x;
    ObjectValues.Obj.Box.lowerLeft.y = lowerLeft.y;
    ObjectValues.Obj.Box.lowerLeft.z = lowerLeft.z;
    ObjectValues.Obj.Box.upperRight.x = upperRight.x;
    ObjectValues.Obj.Box.upperRight.y = upperRight.y;
    ObjectValues.Obj.Box.upperRight.z = upperRight.z;
    ObjectValues.Obj.Box.clockwise = clockwise;

    if( !(status = checkBoxValues( popup, !either, xaxis, yaxis, zaxis ) ) )
        Box( !either,
            xaxis, yaxis, zaxis, center, lowerLeft, upperRight,
            clockwise, primitive );

    creatingObject = False;
    XtPopdown( popup );
    XtDestroyWidget( popup );
}


int
checkBoxValues( w, method, xaxis, yaxis, zaxis )
Widget w;
int method;
float xaxis, yaxis, zaxis;
{
    char buffer[80];
    int errors = 0;

    if( !method ) return errors;

    if( NEAR_ZERO( xaxis ) ) {
        sprintf( buffer, "Error -- Required Condition: xaxis(%.2f) > 0.0\n",
            xaxis );
        message( w, buffer );
        errors++;
    }
    if( NEAR_ZERO( yaxis ) ) {
        sprintf( buffer, "Error -- Required Condition: yaxis(%.2f) > 0.0\n",
            yaxis );
        message( w, buffer );
        errors++;
    }
    if( NEAR_ZERO( zaxis ) ) {
        sprintf( buffer, "Error -- Required Condition: zaxis(%.2f) > 0.0\n",
            zaxis );
        message( w, buffer );
        errors++;
    }
    return errors;
}
